local PileSeller = _G.PileSeller

local psSellingBoxFrame = CreateFrame("FRAME", "PileSeller_SellingBoxFrame", UIParent, "ThinBorderTemplate")


PileSeller:MakeMovable(psSellingBoxFrame)
psSellingBoxFrame:Hide()
psSellingBoxFrame:SetSize(350, 215)
psSellingBoxFrame:SetPoint("CENTER", UIParent)
psSellingBoxFrame.bg = psSellingBoxFrame:CreateTexture()
psSellingBoxFrame.bg:SetAllPoints(psSellingBoxFrame)
psSellingBoxFrame.bg:SetTexture(.1,.1,.1,.8)
psSellingBoxFrame.lblSelling = psSellingBoxFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
psSellingBoxFrame.lblSelling:SetPoint("TOP", psSellingBoxFrame, 0, -10, "BOTTOM")
psSellingBoxFrame.lblSelling:SetText("Do you want to sell these items?")
psSellingBoxFrame:SetFrameStrata("DIALOG")


psSellingBoxFrame.itemsScroll = CreateFrame("ScrollFrame", "PileSeller_SellingBoxFrame_Scroll", psSellingBoxFrame, "UIPanelScrollFrameTemplate")
psSellingBoxFrame.itemsScroll:SetPoint("CENTER", psSellingBoxFrame, "CENTER", 0, 15)
psSellingBoxFrame.itemsScroll:SetSize(260, 120)
psSellingBoxFrame.itemsScroll:SetClampedToScreen(true)

local tex = psSellingBoxFrame.itemsScroll:CreateTexture(nil, "BACKGROUND")
tex:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
tex:SetVertexColor(0,0,0,1)
tex:SetAllPoints()

psSellingBoxFrame.itemsScroll.border = CreateFrame("FRAME", nil, psSellingBoxFrame.itemsScroll)
psSellingBoxFrame.itemsScroll.border:SetSize(260, 120)
psSellingBoxFrame.itemsScroll.border:SetPoint("LEFT", psSellingBoxFrame.itemsScroll)
psSellingBoxFrame.itemsScroll.border:SetBackdrop({
bgFile = [[Interface\Buttons\WHITE8X8]], 
edgeFile = [[Interface\Buttons\WHITE8X8]], 
edgeSize = 1, 
insets = {
        left = 1,
        right = 1,
        top = 1,
        bottom = 1
    }
})
psSellingBoxFrame.itemsScroll.border:SetBackdropColor(.27,.27,.27, .3)
psSellingBoxFrame.itemsScroll.border:SetBackdropBorderColor(0, 0, 0)
-- Actual content of the scroll frame
psSellingBoxFrame.itemsScroll.content = CreateFrame("Frame", "PileSeller_SellingBoxFrame_SavedScrollContent", psSellingBoxFrame.itemsScroll)
psSellingBoxFrame.itemsScroll.content:SetSize(260, 95)
psSellingBoxFrame.itemsScroll.content:SetPoint("LEFT", psSellingBoxFrame.itemsScroll, "LEFT", 0, 0)
-- Creating the text widget
psSellingBoxFrame.itemsScroll.content.wgt = CreateFrame("SimpleHTML", "PileSeller_SellingBoxFrame_SavedScrollContent_Text", psSellingBoxFrame.itemsScroll.content)
psSellingBoxFrame.itemsScroll.content.wgt:SetFont('Fonts\\FRIZQT__.TTF', 11)
psSellingBoxFrame.itemsScroll.content.wgt:SetSize(240, 11)
psSellingBoxFrame.itemsScroll.content.wgt:SetPoint("LEFT", psSellingBoxFrame.itemsScroll.content, "LEFT", 10, 35)
psSellingBoxFrame.itemsScroll.content.wgt:SetScript("OnHyperlinkEnter", function(self, _, link, ...)
    GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
    GameTooltip:SetHyperlink(link)
    GameTooltip:Show()
end
)
psSellingBoxFrame.itemsScroll.content.wgt:SetScript("OnHyperlinkLeave", function(self, _, link, ...)
    GameTooltip:Hide()
end
)
psSellingBoxFrame.itemsScroll.content.wgt:SetScript("OnHyperlinkClick", function(self, _, link, button)
    if button == "RightButton" then
        PileSeller:removeItem(link, psItems, psSellingBoxFrame.itemsScroll.content)
        psSellingBoxFrame:Hide()
        psSellingBoxFrame:Show()
    else
        if IsShiftKeyDown() then
            ChatEdit_InsertLink(link)
        elseif IsControlKeyDown() then
            local id = PileSeller:getID(link)
            DressUpItemLink(id)
        end
    end
end
)
psSellingBoxFrame.itemsScroll.content.wgt.text = ""


psSellingBoxFrame:SetScript("OnShow", function() 
    PileSeller:PopulateList(psSellingBoxFrame.itemsScroll.content, psItems)
    
end)

if not psSellingBoxFrame.itemsScroll:GetScrollChild() then
    psSellingBoxFrame.itemsScroll:SetScrollChild(psSellingBoxFrame.itemsScroll.content)
end

psSellingBoxFrame.lblTutorial = psSellingBoxFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
psSellingBoxFrame.lblTutorial:SetPoint("BOTTOM", psSellingBoxFrame.itemsScroll, 0, -15, "BOTTOM")
psSellingBoxFrame.lblTutorial:SetText("|cFFFFFFFFright click on an item to remove it|r")

psSellingBoxFrame.btnAccept = CreateFrame("Button", nil, psSellingBoxFrame, "GameMenuButtonTemplate")
psSellingBoxFrame.btnAccept:SetPoint("BOTTOM", psSellingBoxFrame, "BOTTOM", -45, 5)
psSellingBoxFrame.btnAccept:SetSize(85, 26)
psSellingBoxFrame.btnAccept:SetText("Accept")
psSellingBoxFrame.btnAccept:SetScript("OnClick", function() PileSeller.selling = true; psSellingBoxFrame:Hide() end)

psSellingBoxFrame.btnDecline = CreateFrame("Button", nil, psSellingBoxFrame, "GameMenuButtonTemplate")
psSellingBoxFrame.btnDecline:SetPoint("BOTTOM", psSellingBoxFrame, "BOTTOM", 45, 5)
psSellingBoxFrame.btnDecline:SetSize(85, 26)
psSellingBoxFrame.btnDecline:SetText("Decline")
psSellingBoxFrame.btnDecline:SetScript("OnClick", function() psSellingBoxFrame:Hide(); psItems = {} end)

PileSeller.sellingBox = psSellingBoxFrame


